unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    Label1: TLabel;
    Label5: TLabel;
    OpenDialog2: TOpenDialog;
    Button3: TButton;
    Edit3: TEdit;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    Label2: TLabel;
    Edit4: TEdit;
    Button5: TButton;
    Button6: TButton;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s, kette1, kette2, kette1_ord, kette2_ord: string;

  zeichen: Array[1..20] of Char;   {max. 20 versch. Symbole}
  kette1_ord_numbers, kette2_ord_numbers: Array[1..20000] of Integer;  {Kette maximal 20000 Zeichen lang}

  sourcefile1, sourcefile2, coordfile: text;
  i, j, k, x, y, z: integer;


implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 Opendialog1.Filter := 'Proteinkettendatei (*.ptn)|*.PTN';
 Opendialog1.Execute;
 Edit1.Text:=Opendialog1.Filename;
 s:=Opendialog1.Filename;
 Repeat
  if s[length(s)]<>'.' then delete(s, length(s), 1); {Dateiextension bis zum Punkt lschen}
 Until s[length(s)]='.';
 Edit3.Text:=s+'cor';  {automatischer Vorschlag fr Namen der Zieldatei}
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Opendialog2.Filter := 'Proteinkettendatei (*.ptn)|*.PTN';
 Opendialog2.Execute;
 Edit2.Text:=Opendialog2.Filename;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Savedialog1.Filter := 'Koordinatendatei (*.cor)|*.COR';
 Savedialog1.Execute;
 if Savedialog1.Filename[length(Savedialog1.Filename)-3]+Savedialog1.Filename[length(Savedialog1.Filename)-2]+Savedialog1.Filename[length(Savedialog1.Filename)-1]+Savedialog1.Filename[length(Savedialog1.Filename)]<>'.cor'
  then Savedialog1.Filename := Savedialog1.Filename+'.cor';
 Edit3.Text:=Savedialog1.Filename;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 if (Edit1.Text='') or (Edit2.Text='') or (Edit1.Text='<Quelldatei1>') or (Edit2.Text='<Quelldatei2>') then Application.Messagebox('Es wurde keine oder nicht alle Quelldateien angegeben', 'Fehler', 48+0)
  else if (Edit3.Text='') or (Edit3.Text='<Koordinatendatei>') then Application.Messagebox('Es wurde keine Zieldatei angegeben', 'Fehler', 48+0)
  else
   begin
    Assignfile(sourcefile1, Edit1.Text);
    Reset(sourcefile1);
    Readln(sourcefile1, kette1);
    Closefile(sourcefile1);
    Assignfile(sourcefile2, Edit2.Text);
    Reset(sourcefile2);
    Readln(sourcefile2, kette2);
    Closefile(sourcefile2);

    Assignfile(coordfile, Edit3.Text);
    Rewrite(coordfile);
    Append(coordfile);
    Writeln(coordfile, IntToStr(length(kette1)));  {Lnge fr X}
    Writeln(coordfile, IntToStr(length(kette2)));  {Lnge fr Y}


    For i:=1 to ListBox1.Items.Count do
     zeichen[i]:=listbox1.Items[i-1][1];
{    zeichen:='acdefghiklmnpqrstvwy';  }

    x:=1; y:=1; kette1_ord:=''; kette2_ord:='';
    For z:=1 to ListBox1.Items.Count do
      { Sortieren der Ketten in Form   a a a a a  a b b b c d d ...
                                       0 1 3 7 8 19 0 2 4 0 0 6 ... }
{     kette1_ord:=kette1_ord+zeichen[z];
     kette1_ord_numbers[x]:=0; x:=x+1;
     kette2_ord:=kette2_ord+zeichen[z];
     kette2_ord_numbers[y]:=0; y:=y+1;      }
     begin
      For i:=1 to length(kette1) do
       if kette1[i]=zeichen[z] then
        begin
         kette1_ord:=kette1_ord+zeichen[z];
         kette1_ord_numbers[x]:=i;
         x:=x+1;
        end;
      For i:=1 to length(kette2) do
       if kette2[i]=zeichen[z] then
        begin
         kette2_ord:=kette2_ord+zeichen[z];
         kette2_ord_numbers[y]:=i;
         y:=y+1;
        end;
     end;

    i:=1; j:=1;
    For z:=1 to ListBox1.Items.Count do
      { Verknpfen der Ziffern aller a's in kette1_ord und kette2_ord
        (die zugehrigen Ziffern stehen jeweils auf gleicher Position
         in den Listen kette1_ord_numbers und kette2_ord_numbers);
        ... aller c's usw. }
     begin
      k:=j;
      While kette1_ord[i]=zeichen[z] do
       begin
        j:=k;
        While kette2_ord[j]<=zeichen[z] do  {kleinergleich Vergleich der ASCII-Werte, falls in Kette1 ein Buchstabe fehlt, der in Kette2 vorkommt}
         begin
          if kette1_ord[i]=kette2_ord[j]
           then Writeln(coordfile, IntToStr(kette1_ord_numbers[i]) + ',' + IntToStr(kette2_ord_numbers[j]));
          j:=j+1;
         end;
        i:=i+1;
       end;
     end;

    Closefile(coordfile);
    Application.MessageBox('Umwandlung erfolgreich abgeschlossen', 'Information', 64+0)
   end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 if (Edit4.Text<>'') and (ListBox1.Items.Count<20) then ListBox1.Items.Add(Edit4.Text);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 i:=0;
 while i<=(ListBox1.Items.Count-1) do
  begin
   if ListBox1.Selected[i]=True then ListBox1.Items.Delete(i);
   i:=i+1;
  end;
end;

end.
